Leetcode: Frog Jump

时间:2021-01-26 23:18:42
A frog is crossing a river. The river is divided into x units and at each unit there may or may not exist a stone. The frog can jump on a stone, but it must not jump into the water.

Given a list of stones' positions (in units) in sorted ascending order, determine if the frog is able to cross the river by landing on the last stone. Initially, the frog is on the first stone and assume the first jump must be 1 unit.

If the frog's last jump was k units, then its next jump must be either k - 1, k, or k + 1 units. Note that the frog can only jump in the forward direction.

Note:

The number of stones is ≥ 2 and is < 1,100.
Each stone's position will be a non-negative integer < 231.
The first stone's position is always 0.
Example 1: [0,1,3,5,6,8,12,17] There are a total of 8 stones.
The first stone at the 0th unit, second stone at the 1st unit,
third stone at the 3rd unit, and so on...
The last stone at the 17th unit. Return true. The frog can jump to the last stone by jumping
1 unit to the 2nd stone, then 2 units to the 3rd stone, then
2 units to the 4th stone, then 3 units to the 6th stone,
4 units to the 7th stone, and 5 units to the 8th stone.
Example 2: [0,1,2,3,4,8,9,11] Return false. There is no way to jump to the last stone as
the gap between the 5th and 6th stone is too large.

Solution 1: Backtracking, but will TLE

 public class Solution {
public boolean canCross(int[] stones) {
HashSet<Integer> stonePos = new HashSet<Integer>();
for (int stone : stones) {
stonePos.add(stone);
}
return helper(stonePos, 0, 0, stones[stones.length-1]);
} public boolean helper(HashSet<Integer> stonePos, int pos, int jump, int last) {
if (pos == last) return true;
for (int diff=-1; diff<=1; diff++) {
int nextJump = jump + diff;
if (nextJump <= 0) continue;
if (stonePos.contains(pos+nextJump)) {
if (helper(stonePos, pos+nextJump, nextJump, last))
return true;
}
}
return false;
}
}

Better Solution: DP (refer to https://discuss.leetcode.com/topic/59903/very-easy-to-understand-java-solution-with-explanations)

Use map to represent a mapping from the stone (not index) to the steps that can be taken from this stone.

so this will be

[0,1,3,5,6,8,12,17]

{17=[], 0=[1], 1=[1, 2], 3=[1, 2, 3], 5=[1, 2, 3], 6=[1, 2, 3, 4], 8=[1, 2, 3, 4], 12=[3, 4, 5]}

Notice that no need to calculate the last stone.

On each step, we look if any other stone can be reached from it, if so, we update that stone's steps by adding step, step + 1, step - 1. If we can reach the final stone, we return true. No need to calculate to the last stone.

 public class Solution {
public boolean canCross(int[] stones) {
if (stones.length <= 1) return true;
HashMap<Integer, HashSet<Integer>> map = new HashMap<Integer, HashSet<Integer>>();
for (int stonePos : stones) {
map.put(stonePos, new HashSet<Integer>());
}
map.get(0).add(1);
for (int i=0; i<stones.length-1; i++) {
int stonePos = stones[i];
HashSet<Integer> steps = map.get(stonePos);
for (int step : steps) {
int reach = stonePos + step;
if (reach == stones[stones.length-1]) return true;
HashSet<Integer> set = map.get(reach);
if (set != null) {
set.add(step);
set.add(step+1);
if (step-1 > 0) set.add(step-1);
}
}
}
return false;
}
}

下面我自己写的这个DP思路可能更简单易写一点:维护一个HashMap<int pos, HashSet<Integer> set>, pos是stones数组里第i个石头,set存该石头possible的next jump。所以initialize: map.get(0).add(1).  这个算法没有上面那个快,但是更容易想清楚

 public class Solution {
public boolean canCross(int[] stones) {
HashMap<Integer, HashSet<Integer>> map = new HashMap<>();
map.put(0, new HashSet<Integer>());
map.get(0).add(1); for (int i=1; i<stones.length; i++) {
map.put(i, new HashSet<Integer>());
for (int j=0; j<i; j++) {
int dis = stones[i] - stones[j];
HashSet<Integer> setj = map.get(j); //j's possible next jumps
if (setj.contains(dis)) {
if (dis - 1 > 0) map.get(i).add(dis-1);
map.get(i).add(dis);
map.get(i).add(dis+1);
}
}
} return map.get(stones.length-1).size() != 0;
}
}